#ifndef ADDSHORTCUT_H
#define ADDSHORTCUT_H

#include <QDialog>
#include <QMap>
#include "Profil.h"
#include "KeyboardHandle.h"

QT_BEGIN_NAMESPACE
class QLabel;
class QComboBox;
class QLineEdit;
class QPushButton;
class QTableView;
class QTreeView;
class QStandardItemModel;
class QAbstractItemModel;
QT_END_NAMESPACE


class					AddProfilWindow : public QDialog
{
    Q_OBJECT
    
public:
    AddProfilWindow(QWidget *parent);
	AddProfilWindow(const AddProfilWindow &);
	~AddProfilWindow();
	QStandardItemModel*	getModel() const;
	void	setProgramsModel();
	// LABELS
    QLabel				*_actionLabel;
	QLabel				*_nameLabel;
	QLabel				*_keyLabel;
	QLabel				*_vrpnIpLabel;
		
	// WIDGETS
	QLineEdit			*_vrpnIp;
	QLineEdit			*_profilName;
	QPushButton			*_okButton;
	QPushButton			*_cancelButton;
	QPushButton			*_addShortcut;
	QPushButton			*_removeShortcut;
	QStandardItemModel	*_ShortcutModel;
	QTableView*			getView() const;
    QComboBox			*_action;
	KeyboardHandle		*_key;
	QTableView			*_shortcutView;
	QMap<int, int>		_shortcuts;
	QMap<QString, QString>	_programs;
	
public slots:
	void				addShortcut();
	void				removeShortcut();
private:
	void				initWindow(); // initialise les widgets
	void				createWindow(); // initialise le layout
};

#endif // ADDSHORTCUT_H