#ifndef EYES_ACTIONS_CALLBACK_H
#define EYES_ACTIONS_CALLBACK_H

#include <QObject>
#include "def.h"

namespace eyetrack
{

/*!
** \brief class eyes_actions_callback
*/
class eyes_actions_callback : public QObject
{
	Q_OBJECT

public:
	void	emit_signal_direction(const Direction dir);
	void	emit_signal_blink(const eyes_blink blink);
	void	emit_signal_display_help(bool status);
	void	emit_signal_no_device();
	void	emit_signal_eyes_problem(bool status);

signals:
	// Les signaux pour les clignements d'yeux
	void	Sig_BlinkLeft();
	void	Sig_BlinkRight();
	void	Sig_BlinkDouble();
	// Les signaux pour les directions regardes
	void	Sig_LookTop();
	void	Sig_LookRight();
	void	Sig_LookBottom();
	void	Sig_LookLeft();
	void	Sig_LookUnknown();
	// Le signal d'affichage de l'aide
	void	Sig_DisplayHelp(bool status);
	// Signal indiquant que les yeux ne sont pas correctement dtects
	void	Sig_EyesProblem(bool status);
	// Signal indiquant un problme avec le priphrique
	void	Sig_No_Device();
};

}

#endif // !EYES_ACTIONS_CALLBACK_H