/* IOT Copyright (C) 2010 CEG development team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Authors: CEG <ceg@ionlythink.com>, http://www.ionlythink.com
 */

#ifndef PROFIL_H_
#define PROFIL_H_

#include <QMap>
#include <QString>
#include <iostream>

class Profil
{
public:
	Profil();
	Profil(const QString& name);
    Profil(const QString& name, const QString& vrpnIp, const QMap<int, int>& shortcuts);
    ~Profil();

	QString			_name;
	QString			_vrpnIp;
	QMap<int, int>	_shortcuts;

	bool			operator == (const Profil& other);
	void			setVrpnIp(const QString& vrpnIp);
	void			setShortcuts(const QMap<int, int>& shortcuts);
	const QString&	getVrpnIp();
};

#endif // PROFIL_H_
