#include "KeyboardHandle.h"
#include <QKeyEvent>

KeyboardHandle::KeyboardHandle(QWidget *parent) :
    QLineEdit(parent)
{
}

void KeyboardHandle::keyPressEvent(QKeyEvent *e)
{
  // Quand le widget est dsactiv on n'accepte pas le changement de touche
  if (!isEnabled())
  {
    QLineEdit::keyPressEvent(e);
    return;
  }

  // Filtre l'entre normale du QLineEdit
  e->accept();

  // Si c'est un caractre imprimable
  if(!e->text().isEmpty())
  {
    QKeySequence sequence(e->key() | e->modifiers());
	this->key = e->key();
    setText(sequence.toString()); // Emettra le signal textChanged(QString)
  }
}