
//#include "qevent.h"
//#include "qcoreevent.h"
//#include <QApplication>
//#include <QObject>
//#include <qcoreevent.h>
//#include <QEvent>
#include "MainController.h"
#include "eyes_actions_callback_func.h"

using namespace eyetrack;

eyes_actions_callback_func::eyes_actions_callback_func(QObject* parent) : mMC(dynamic_cast<MainController*>(parent))
{
	mKey = Qt::Key_No;
	mTimer.start();
}

eyes_actions_callback_func::~eyes_actions_callback_func()
{

}

void		eyes_actions_callback_func::keyemul(const Qt::Key key)
{
	quint32	k;
	quint32 key2 = (quint32)key;

	switch (key2)
	{
	case Qt::Key_Enter:
#ifdef _WIN32
		k = VK_RETURN;
#else
		k = XK_Return;
#endif
		break ;

	case Qt::Key_Up:
#ifdef _WIN32
		k = VK_UP;
#else
		k = XK_Up;
#endif
		break ;

	case Qt::Key_Right:
#ifdef _WIN32
		k = VK_RIGHT;
#else
		k = XK_Right;
#endif
		break ;

	case Qt::Key_Down:
#ifdef _WIN32
		k = VK_DOWN;
#else
		k = XK_Down;
#endif
		break ;

	case Qt::Key_Left:
#ifdef _WIN32
		k = VK_LEFT;
#else
		k = XK_Left;
#endif
		break ;
	}

#ifdef _WIN32
	keybd_event(k, 0, 0, 0);
#else
	if (mMC->isInit)
	  mMC->_xAction.keyPress(k);
#endif
}

void		eyes_actions_callback_func::Slt_BlinkDouble()
{
	if (mKey != Qt::Key_Enter)
	{
		mKey = Qt::Key_Enter;
		if (mTimer.hasExpired(500))
		{
			keyemul(mKey);
			mTimer.restart();
		}
	}
}

void		eyes_actions_callback_func::Slt_BlinkLeft()
{
	// TODO: Whatever
}

void		eyes_actions_callback_func::Slt_BlinkRight()
{
	// TODO: Whatever
}

void		eyes_actions_callback_func::Slt_LookLeft()
{
	mKey = Qt::Key_Left;
	if (mTimer.hasExpired(700))
	{
		keyemul(mKey);
		mTimer.restart();
	}
}

void		eyes_actions_callback_func::Slt_LookBottom()
{
	mKey = Qt::Key_Down;
	if (mTimer.hasExpired(700))
	{
		keyemul(mKey);
		mTimer.restart();
	}
}

void		eyes_actions_callback_func::Slt_LookTop()
{
	mKey = Qt::Key_Up;
	if (mTimer.hasExpired(700))
	{
		keyemul(mKey);
		mTimer.restart();
	}
}

void		eyes_actions_callback_func::Slt_LookRight()
{
	mKey = Qt::Key_Right;
	if (mTimer.hasExpired(700))
	{
		keyemul(mKey);
		mTimer.restart();
	}
}

void		eyes_actions_callback_func::Slt_LookUnknown()
{
	mKey = Qt::Key_No;
}
